#include <bits/stdc++.h>
using namespace std;
ifstream fin("graunte.in");
ofstream fout("graunte.out");

const int NMAX = 1e6 + 5;
const int VMAX = 1e6 + 5;
const int MOD = 1789;

int n, q1, q2;
int coprimeMaiMici[VMAX];
long long marsLinii[NMAX];

void numaraCoprimeMaiMici() {
    for (int i = 1; i < VMAX; i++) {
        coprimeMaiMici[i] = i;
    }
    for (int i = 2; i < VMAX; i++) {
        if (coprimeMaiMici[i] == i) {
            for (int j = i; j < VMAX; j += i) {
                coprimeMaiMici[j] = 1LL * coprimeMaiMici[j] * (i - 1) / i;
            }
        }
    }
}

int calculeazaSumaCoprime(int v) {
    return (1LL * v * coprimeMaiMici[v] / 2) % MOD;
}

void adauga(int primaLinie, int ultimaLinie, long long valoare) {
    marsLinii[primaLinie] += valoare;
    marsLinii[ultimaLinie + 1] -= valoare;
}

pair<int, int> obtineCeaMaiLungaSecventaDeLinii(long long k) {
    pair<int, int> raspuns = {-1, -1};

    int primaLinie = 1;
    int ultimaLinie = 1;
    long long sum = marsLinii[primaLinie];

    if (sum <= k) {
        raspuns = {primaLinie, ultimaLinie};
    }

    for (ultimaLinie = 2; ultimaLinie <= n; ultimaLinie++) {
        sum += marsLinii[ultimaLinie];
        while (primaLinie <= ultimaLinie && sum > k) {
            primaLinie++;
            sum -= marsLinii[primaLinie - 1];
        }

        if (primaLinie <= ultimaLinie && 
                    (raspuns.first == -1 || ultimaLinie - primaLinie > raspuns.second - raspuns.first)) {
            raspuns = {primaLinie, ultimaLinie};
        }
    }

    return raspuns;
}

int main() {
    fin >> n >> q1 >> q2;

    numaraCoprimeMaiMici();

    while (q1--) {
        int a, b, c, d, v;
        fin >> a >> b >> c >> d >> v;

        long long w = calculeazaSumaCoprime(v);
        long long plusLinie = 1LL * (d - b + 1) * w;
        adauga(a, c, plusLinie);
    }

    for (int i = 2; i <= n; i++) {
        marsLinii[i] += marsLinii[i - 1];
    }

    while (q2--) {
        long long k;
        fin >> k;

        pair<int, int> raspuns = obtineCeaMaiLungaSecventaDeLinii(k);
        fout << raspuns.first << " " << raspuns.second << "\n";
    }

    return 0;
}
