#include <bits/stdc++.h>
using namespace std;
ifstream fin("graunte.in");
ofstream fout("graunte.out");

const int NMAX = 5005;
const int VMAX = 1e6 + 5;
const int MOD = 1789;

int n, q1, q2;
int coprimeMaiMici[VMAX];
int mars[NMAX][NMAX];
long long sumaLinii[NMAX];

void numaraCoprimeMaiMici() {
    for (int i = 1; i < VMAX; i++) {
        coprimeMaiMici[i] = i;
    }
    for (int i = 2; i < VMAX; i++) {
        if (coprimeMaiMici[i] == i) {
            for (int j = i; j < VMAX; j += i) {
                coprimeMaiMici[j] = 1LL * coprimeMaiMici[j] * (i - 1) / i;
            }
        }
    }
}

int calculeazaSumaCoprime(int v) {
    return (1LL * v * coprimeMaiMici[v] / 2) % MOD;
}

void adauga(int a, int b, int c, int d, int w) {
    mars[a][b] += w;
    mars[a][d + 1] -= w;
    mars[c + 1][b] -= w;
    mars[c + 1][d + 1] += w;
}

void calculeazaSumeLinii() {
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            sumaLinii[i] += mars[i][j];
        }
    }
}

pair<int, int> obtineCeaMaiLungaSecventaDeLinii(long long k) {
    pair<int, int> raspuns = {-1, -1};

    int primaLinie = 1;
    int ultimaLinie = 1;
    long long sum = sumaLinii[primaLinie];

    if (sum <= k) {
        raspuns = {primaLinie, ultimaLinie};
    }

    for (ultimaLinie = 2; ultimaLinie <= n; ultimaLinie++) {
        sum += sumaLinii[ultimaLinie];
        while (primaLinie <= ultimaLinie && sum > k) {
            primaLinie++;
            sum -= sumaLinii[primaLinie - 1];
        }

        if (primaLinie <= ultimaLinie && 
                    (raspuns.first == -1 || ultimaLinie - primaLinie > raspuns.second - raspuns.first)) {
            raspuns = {primaLinie, ultimaLinie};
        }
    }

    return raspuns;
}

int main() {
    fin >> n >> q1 >> q2;

    numaraCoprimeMaiMici();

    while (q1--) {
        int a, b, c, d, v;
        fin >> a >> b >> c >> d >> v;

        long long w = calculeazaSumaCoprime(v);
        adauga(a, b, c, d, w);
    }

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            mars[i][j] += mars[i - 1][j] + mars[i][j - 1] - mars[i - 1][j - 1];
        }
    }

    calculeazaSumeLinii();

    while (q2--) {
        long long k;
        fin >> k;

        pair<int, int> raspuns = obtineCeaMaiLungaSecventaDeLinii(k);
        fout << raspuns.first << " " << raspuns.second << "\n";
    }

    return 0;
}
